#include <iostream>
#include <cassert>

using namespace std;

//    nibble (4 )   
char nibble_to_hex(uint8_t i) {
    //     
    char digits[] = "0123456789abcdef";

    //    
    assert(0x0 <= i && i <= 0xf);

    //    nibble   digits
    return digits[i];
}

//          
void print_in_hex(uint8_t byte) {
    //    
    cout << "Hex: " << nibble_to_hex(byte >> 4) << nibble_to_hex(byte & 0xf) << endl;

    //    
    cout << "Binary: ";
    for (int i = 7; i >= 0; --i) {
        cout << ((byte >> i) & 1);
    }
    cout << endl;
}

int main() {
    //   nibble_to_hex
    //for (int i = 0; i <= 0xf; ++i) {
        //assert(nibble_to_hex(i) == nibble_to_hex(i));
    //}

    assert(nibble_to_hex(0x0) == '0');
    assert(nibble_to_hex(0x1) == '1');
    assert(nibble_to_hex(0x2) == '2');
    assert(nibble_to_hex(0x3) == '3');
    assert(nibble_to_hex(0x4) == '4');
    assert(nibble_to_hex(0x5) == '5');
    assert(nibble_to_hex(0x6) == '6');
    assert(nibble_to_hex(0x7) == '7');
    assert(nibble_to_hex(0x8) == '8');
    assert(nibble_to_hex(0x9) == '9');
    assert(nibble_to_hex(0xa) == 'a');
    assert(nibble_to_hex(0xb) == 'b');
    assert(nibble_to_hex(0xc) == 'c');
    assert(nibble_to_hex(0xd) == 'd');
    assert(nibble_to_hex(0xe) == 'e');
    assert(nibble_to_hex(0xf) == 'f');

    //       
    uint8_t test_byte = 0x2f;
    print_in_hex(test_byte);

    return 0;
}


int main_calc() {
    uint16_t operand1, operand2;
    char operation;

    cout << "Enter the first operand (in hexadecimal): ";
    cin >> std::hex >> operand1;

    cout << "Enter the bitwise operation (&, |, or ^): ";
    cin >> operation;

    cout << "Enter the second operand (in hexadecimal): ";
    cin >> std::hex >> operand2;

    uint16_t result = perform_bitwise_operation(operand1, operation, operand2);

    cout << "\nCalculation Result:" << endl;
    print_calculation(result);

    return 0;
}

int main_students() {
    // Student
    Student students[3] = {
        Student("Alice", 2019, 4.5, 0, 3, nullptr),
        Student("Bob", 2019, 4.2, 1, 2, nullptr),
        Student("Charlie", 2019, 4.7, 1, 4, nullptr) //  ,      groupLeader
    };

    // Details
    for (int i = 0; i < 3; ++i) {
        std::cout << "\nDetails of Student " << i + 1 << ":" << std::endl;
        printStudentDetails(students[i]);
    }

    return 0;
}
